#include <stdio.h>
#include <stdlib.h>
#ifdef __DEBUG__
#include <fcntl.h>
#include <io.h>
#endif


#define MAXK 1000
#define MAXM 5000

int Tree[MAXK][8];
int Tc[MAXK];
int P[MAXK];
int D[MAXK];
int C[MAXM];
int O[MAXK];
int List[MAXK];
int Lc;
int K,M,I,J;

int cmp(const void *a, const void *b)
{
  return *(int*)a-*(int*)b;
}

void Mark(int h, int n)
{
  if (O[h]==0)
    O[h]=n;
}

void MarkPath(int h1, int h2, int n)
{
  while (D[h1]>D[h2])
  {
    Mark(h1,n);
    h1=P[h1];
  }
  while (D[h2]>D[h1])
  {
    Mark(h2,n);
    h2=P[h2];
  }
  while (h1!=h2)
  {
    Mark(h1,n);
    Mark(h2,n);
    h1=P[h1];
    h2=P[h2];
  }
  Mark(h1,n);
}


void InvertTree(int no, int d, int p)
{
  int i;

  P[no]=p;
  D[no]=d;
  for (i=0;i<Tc[no];i++)
    if (Tree[no][i]!=p)
      InvertTree(Tree[no][i],d+1,no);
}


int main()
{
  int d;
  int i;
  int a,b;
#ifdef __DEBUG__
int fd=open("E.IN",O_RDONLY|O_TEXT);
dup2(fd,0);
#endif

  scanf("%d",&d);
  while (d--)
  {
    scanf("%d%d%d%d",&K,&M,&I,&J);
    for (i=0;i<K;i++)
      Tc[i]=0;
    for (i=0;i<K-1;i++)
    {
      scanf("%d%d",&a,&b);
      a--;
      b--;
      Tree[a][Tc[a]++]=b;
      Tree[b][Tc[b]++]=a;
    }
    InvertTree(0,0,-1);

    for (i=0;i<M;i++)
    {
      scanf("%d",&a);
      C[i]=a-1;
    }

    for (i=0;i<K;i++)
      O[i]=0;
    for (i=0;i<I;i++)
    {
      scanf("%d%d",&a,&b);
      MarkPath(C[a-1],C[b-1],1);
    }
    for (i=0;i<J;i++)
    {
      scanf("%d%d",&a,&b);
      MarkPath(C[a-1],C[b-1],2);
    }

    Lc=0;
    for (i=0;i<K;i++)
      if (O[i]==2)
        List[Lc++]=i;
    qsort(List,Lc,sizeof(int),cmp);

    for (i=0;i<Lc;i++)
      printf("%d\n",List[i]+1);
    printf("\n");
  }

  return 0;
}
